import { J as Json, O as ObjectStorage, L as LogHandlerOptions, dJ as LogMessage, a as LogHandler, b as LogLevelAliasType, c as LoggerInterface } from './uuid-c844fcaa.js';
export { ej as ArgumentsType, d3 as AsyncMutex, dn as AsyncReturnType, aa as BinInput, B as BinaryEncoder, n as CRYPTO_DEFAULT_ALG, o as CRYPTO_DEFAULT_DERIVE_ALG, p as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, dV as Channel, dU as ChannelMessageEvent, e6 as CryptoEncoder, aV as DAY_MS, aQ as Day, aX as DayInput, aP as DayInputLegacy, aW as DayValue, bi as DecimalInput, bh as DecimalValue, d$ as DefaultListener, dy as DefaultLogger, br as Difference, bq as DifferenceType, cX as Disposer, cW as DisposerFunction, e0 as Emitter, dZ as EmitterAllHandler, dY as EmitterHandler, e3 as Encoder, bR as FilterFunction, e5 as JsonEncoder, d_ as ListenerSignature, dW as LocalChannel, dz as LogLevel, dH as LogLevelAlias, dI as LogLevelAliasKey, dA as LogLevelAll, dB as LogLevelDebug, dE as LogLevelError, dF as LogLevelFatal, dC as LogLevelInfo, dG as LogLevelOff, dD as LogLevelWarn, dM as LoggerConsoleHandler, dN as LoggerContext, dK as LoggerContextInterface, dT as LoggerMemoryHandler, bS as MapperFunction, eH as MemStorage, eG as MemStorageOptions, e9 as Message, e7 as MessageAction, ed as MessageDefinitions, ee as MessageHub, e8 as MessageResult, eb as MessagesDefaultMethods, ec as MessagesMethods, ea as MessagesOptions, d2 as Mutex, eN as NestedArray, e4 as NoopEncoder, d7 as PoolConfig, da as PoolTask, db as PoolTaskEvents, d8 as PoolTaskFn, d6 as PoolTaskIdConflictResolution, d9 as PoolTaskState, bv as Primitive, dd as Progress, eh as PubSub, en as RPCFn, em as RPCOptions, el as RPCOptionsBasic, eo as RPCReturn, aG as RenderMessagesOptions, ek as ReturnType, cf as RoundingMode, dr as SerialQueue, cq as SortableItem, dq as TaskEvents, dp as TaskFn, aO as Uint8ArrayToDataUri, aq as Uint8ArrayToHexDump, ap as Uint8ArrayToJson, ae as Uint8ArrayToString, cM as Uint8ArrayToWords, cV as UseDefer, cT as UseDispose, cR as UseDisposeConfig, er as UseRPCHubType, cQ as XRX, ac as _decodeUtf8Polyfill, ab as _encodeUtf8Polyfill, $ as _useBase, Y as arrayAvg, Z as arrayBatches, M as arrayEmptyInPlace, I as arrayFilterInPlace, D as arrayFlatten, E as arrayIntersection, Q as arrayIsEqual, V as arrayMax, W as arrayMin, z as arrayMinus, U as arrayRandomElement, G as arrayRemoveElement, H as arraySetElement, S as arrayShuffle, T as arrayShuffleForce, R as arrayShuffleInPlace, N as arraySorted, P as arraySortedNumbers, X as arraySum, F as arraySymmetricDifference, K as arrayToggleInPlace, A as arrayUnion, y as arrayUnique, d as assert, e as assertCondition, c2 as avg, c0 as between, k as bitfield, l as blobToArrayBuffer, aN as blobToDataUri, m as blobToUint8Array, dL as browserSelectColorByName, cI as cloneJsonObject, cH as cloneObject, cb as cmp, ca as composeOrderby, _ as createArray, j as createBinaryStreamDecoder, i as createBinaryStreamEncoder, dX as createLocalChannelPair, de as createPromise, ef as createPromiseProxy, w as csvParse, x as csvParseToObjects, v as csvStringify, aM as dataUriToBlob, aL as dataUriToMimeType, aK as dataUriToUint8Array, aU as dateStringToDays, aT as day, a_ as dayDay, be as dayDiff, b2 as dayFromAny, b4 as dayFromDate, b5 as dayFromDateGMT, b9 as dayFromParts, ba as dayFromString, b7 as dayFromTimestamp, b1 as dayFromToday, bg as dayIterator, aZ as dayMonth, bb as dayMonthStart, bd as dayOffset, bf as dayRange, b0 as dayToDate, b3 as dayToDateGMT, a$ as dayToParts, b8 as dayToString, b6 as dayToTimestamp, aY as dayYear, bc as dayYearStart, dt as debounce, cw as deburr, bj as decimal, bm as decimalCentsPart, bk as decimalFromCents, bl as decimalToCents, a4 as decodeBase16, a2 as decodeBase32, a6 as decodeBase58, a8 as decodeBase62, h as decodeJson, u as decrypt, bn as deepEqual, bp as deepMerge, bo as deepStripUndefinedInPlace, s as deriveKeyPbkdf2, eD as detect, bs as diffObjects, q as digest, eM as duration, cG as empty, a3 as encodeBase16, a1 as encodeBase32, a5 as encodeBase58, a7 as encodeBase62, g as encodeJson, cz as encodeQuery, t as encrypt, cs as endSortWeight, cB as ensureKey, cC as ensureKeyAsync, an as equalBinary, bt as escapeHTML, ce as escapeRegExp, a9 as estimateSizeForBase, f as fatal, eu as fetchBasic, ev as fetchJson, ez as fetchOptionsBasicAuth, ex as fetchOptionsFormURLEncoded, ey as fetchOptionsJson, ew as fetchText, cE as first, aJ as fixBrokenUth8String, aR as forEachDay, cL as forTimes, aH as formatMessages, eJ as formatMilliseconds, al as fromBase64, am as fromBase64String, au as fromCamelCase, ai as fromHex, eC as getGlobal, du as getGlobalContext, e1 as getGlobalEmitter, dw as getGlobalLogger, dx as getGlobalLoggerIfExists, dO as getNamespaceFilterString, eB as getNavigator, eL as getPerformanceTimestamp, bX as getSecureRandom, bY as getSecureRandomIfPossible, eI as getTimestamp, eA as getWindow, es as httpMethod, dg as immediate, by as isArray, bF as isBoolean, eE as isBrowser, bK as isEmpty, ch as isEven, cg as isHalf, bD as isInteger, dv as isLocalHost, bL as isNotEmpty, bJ as isNotNull, bH as isNull, bG as isNullOrUndefined, bC as isNumber, bw as isObject, c4 as isPrime, c3 as isPrimeRX, bx as isPrimitive, dl as isPromise, bz as isRecord, bA as isRecordPlain, bE as isSafeInteger, bB as isString, di as isTimeout, bN as isTruthy, bI as isUint8Array, bM as isValue, dS as joinLogStrings, ag as joinToUint8Array, bQ as jsonStringify, bP as jsonStringifySafe, bO as jsonStringifySorted, ao as jsonToUint8Array, cF as last, e2 as lazyListener, cx as linkifyPlainText, bV as listDistinctUnion, bU as listGroupBy, bW as listOfKey, bT as listQuery, cJ as memoize, cK as memoizeAsync, ct as moveSortWeight, eO as noop, c8 as objectIsEmpty, c6 as objectMap, c7 as objectMergeDisposable, et as parseBasicAuth, eK as parseDate, dQ as parseLogLevel, c9 as parseOrderby, cA as parseQuery, dm as promisify, f8 as qid, bZ as randomBoolean, b$ as randomFloat, b_ as randomInt, r as randomUint8Array, cP as regExpEscape, cO as regExpString, aI as renderMessages, cj as roundDown, cm as roundHalfAwayFromZero, cn as roundHalfDown, co as roundHalfEven, cl as roundHalfOdd, cp as roundHalfTowardsZero, ck as roundHalfUp, ci as roundUp, c5 as seededRandom, f2 as setUuidDefaultEncoding, cD as size, df as sleep, cu as sortedItems, cc as sortedOrderby, cr as startSortWeight, av as stringToBoolean, ax as stringToFloat, aw as stringToInteger, ad as stringToUInt8Array, e_ as suid, eZ as suidBytes, f0 as suidBytesDate, e$ as suidDate, c1 as sum, ds as throttle, dh as timeout, aj as toBase64, ak as toBase64Url, aF as toBool, ar as toCamelCase, as as toCapitalize, at as toCapitalizeWords, aC as toFloat, ah as toHex, cy as toHumanReadableUrl, aD as toInt, aE as toString, af as toUint8Array, cd as toValidFilename, aS as today, dj as tryTimeout, f7 as uname, bu as unescapeHTML, d5 as useAsyncMutex, a0 as useBase, cU as useDefer, cS as useDispose, d1 as useDisposeWithUtils, c$ as useEventListener, d0 as useEventListenerOnce, eF as useExitHandler, cZ as useInterval, c_ as useIntervalPause, dR as useLevelFilter, eg as useMessageHub, d4 as useMutex, dP as useNamespaceFilter, dc as usePool, ei as usePubSub, ep as useRPC, eq as useRPCHub, cv as useSorted, cY as useTimeout, f3 as uuid, f1 as uuid32bit, eT as uuidB32, eQ as uuidB62, eP as uuidBytes, f4 as uuidDecode, eV as uuidDecodeB32, eS as uuidDecodeB62, eY as uuidDecodeV4, f5 as uuidEncode, eU as uuidEncodeB32, eR as uuidEncodeB62, eX as uuidEncodeV4, f6 as uuidIsValid, eW as uuidv4, ay as valueToBoolean, aA as valueToFloat, az as valueToInteger, aB as valueToString, dk as waitOn, cN as wordsToUint8Array } from './uuid-c844fcaa.js';
import * as fs from 'fs';
import { Buffer } from 'node:buffer';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare function setupWebCrypto(): void;
declare function getWebCrypto(): Promise<Crypto>;

interface EnvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
    mode?: string;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: EnvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

declare function getStat(path: string): fs.Stats | undefined;
declare function getFingerprint(path: string): string;
declare function walkSync(rootFolder: string, subFolder?: string, ignoreHidden?: boolean): string[];
declare function files(opt?: {
    basePath?: string;
    pattern?: string | RegExp;
    filter?: (name: string) => boolean;
    ignoreHidden?: boolean;
}): string[];

declare function getStatAsync(path: string): Promise<fs.Stats | undefined>;
declare function getFingerprintAsync(path: string): Promise<string>;
declare function walkSyncAsync(rootFolder: string, subFolder?: string, ignoreHidden?: boolean): Promise<string[]>;
declare function filesAsync(opt?: {
    basePath?: string;
    pattern?: string | RegExp;
    filter?: (name: string) => boolean;
    ignoreHidden?: boolean;
}): Promise<string[]>;

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function isHiddenPath(path: string): boolean;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function globToRegExp(glob: string, opts?: any): RegExp;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): string[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

declare function Logger(name?: string, level?: LogLevelAliasType): LoggerInterface;

export { FileStorage, FileStorageOptions, Json, LogHandler, LogHandlerOptions, LogLevelAliasType, LogMessage, Logger, LoggerFileHandler, LoggerInterface, LoggerNodeHandler, ObjectStorage, colorString, colorStringList, ensureFolder, exists, files, filesAsync, getEnvVariableRelaxed, getFingerprint, getFingerprintAsync, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, getStat, getStatAsync, getWebCrypto, globToRegExp, isHiddenPath, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, setupWebCrypto, stringToPath, toHumanReadableFilePath, toPath, valueToPath, walkSync, walkSyncAsync, writeText };
